Index: src/Parser/PcpParser.hpp
===================================================================
--- src/Parser/PcpParser.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
+++ src/Parser/PcpParser.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -0,0 +1,129 @@
+/*
+ * PcpParser.hpp
+ *
+ *  Created on: 12.06.2010
+ *      Author: heber
+ */
+
+#ifndef PCPPARSER_HPP_
+#define PCPPARSER_HPP_
+
+#include <iostream>
+#include "FormatParser.hpp"
+
+/**
+ * Parser for PCP config files.
+ */
+class PcpParser : public FormatParser {
+public:
+  PcpParser();
+  ~PcpParser();
+  void load(std::istream* file);
+  void save(std::ostream* file);
+
+  bool operator==(const PcpParser& b) const;
+
+private:
+
+  void ParseThermostats(class ConfigFileBuffer * const fb);
+  void OutputAtoms(ostream *file, vector<atom *> &allatoms, map<int, int> &ZtoIndexMap);
+  void OutputElements(ostream *file, vector<atom *> &allatoms, map<int, int> &ZtoIndexMap);
+
+  struct StructParallelization {
+    int ProcPEGamma;
+    int ProcPEPsi;
+  } Parallelization;
+
+  /*
+   * Contains all the paths and names
+   */
+  struct StructPaths {
+    char *databasepath;
+    char *configpath;
+    char *configname;
+    char *mainname;
+    char *defaultpath;
+    char *pseudopotpath;
+  } Paths;
+
+  /*
+   * Contains all Do/Don't switches
+   */
+  struct StructSwitches {
+    int DoConstrainedMD;
+    int DoOutVis;
+    int DoOutMes;
+    int DoOutNICS;
+    int DoOutOrbitals;
+    int DoOutCurrent;
+    int DoFullCurrent;
+    int DoPerturbation;
+    int DoWannier;
+  } Switches;
+
+  /*
+   * Contains parameters regarding localization of orbitals or magnetic perturbation
+   */
+  struct StructLocalizedOrbitals {
+    int CommonWannier;
+    double SawtoothStart;
+    int VectorPlane;
+    double VectorCut;
+    int UseAddGramSch;
+    int Seed;
+    double EpsWannier;
+  } LocalizedOrbitals;
+
+  /*
+   * Contains all step count and other epsilon threshold parameters
+   */
+  struct StructStepCounts {
+    int MaxMinStopStep;
+    int InitMaxMinStopStep;
+
+    int OutVisStep;
+    int OutSrcStep;
+    int MaxPsiStep;
+
+    int MaxOuterStep;
+
+    int MaxMinStep;
+    double RelEpsTotalEnergy;
+    double RelEpsKineticEnergy;
+    int MaxMinGapStopStep;
+    int MaxInitMinStep;
+    double InitRelEpsTotalEnergy;
+    double InitRelEpsKineticEnergy;
+    int InitMaxMinGapStopStep;
+  } StepCounts;
+
+  /*
+   * Contains all parameters specific to the plane wave basis set
+   */
+  struct StructPlaneWaveSpecifics {
+    int PsiType;
+    int MaxPsiDouble;
+    int PsiMaxNoUp;
+    int PsiMaxNoDown;
+    double ECut;
+    int MaxLevel;
+    int RiemannTensor;
+    int LevRFactor;
+    int RiemannLevel;
+    int Lev0Factor;
+    int RTActualUse;
+    int AddPsis;
+    double RCut;
+  } PlaneWaveSpecifics;
+
+  bool FastParsing;
+
+  double Deltat;
+  int IsAngstroem;
+  int RelativeCoord;
+  int StructOpt;
+  int MaxTypes;
+  string basis;
+};
+
+#endif /* PCPPARSER_HPP_ */
Index: src/Parser/TremoloParser.hpp
===================================================================
--- src/Parser/TremoloParser.hpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/Parser/TremoloParser.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -10,5 +10,5 @@
 
 #include <string>
-#include "FormatParser.hpp"
+#include "Parser/FormatParser.hpp"
 
 /**
Index: src/Parser/XyzParser.cpp
===================================================================
--- src/Parser/XyzParser.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/Parser/XyzParser.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -27,5 +27,4 @@
  */
 XyzParser::~XyzParser() {
-  delete(&comment);
 }
 
Index: src/Parser/XyzParser.hpp
===================================================================
--- src/Parser/XyzParser.hpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/Parser/XyzParser.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -10,5 +10,5 @@
 
 #include <string>
-#include "FormatParser.hpp"
+#include "Parser/FormatParser.hpp"
 
 /**
Index: src/ThermoStatContainer.cpp
===================================================================
--- src/ThermoStatContainer.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
+++ src/ThermoStatContainer.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -0,0 +1,52 @@
+/*
+ * ThermoStatContainer.cpp
+ *
+ *  Created on: 12.06.2010
+ *      Author: heber
+ */
+
+#include <cstring>
+
+#include "ConfigFileBuffer.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "ThermoStatContainer.hpp"
+#include "verbose.hpp"
+
+/** Constructor for class ThermoStatContainer.
+ *
+ */
+ThermoStatContainer::ThermoStatContainer() : Thermostat(4), ThermostatImplemented(NULL),
+ThermostatNames(NULL), TempFrequency(2.5), alpha(0.), HooverMass(0.), TargetTemp(0.00095004455), ScaleTempStep(25)
+{
+  ThermostatImplemented = new int[MaxThermostats];
+  ThermostatNames = new char *[MaxThermostats];
+  for (int j=0;j<MaxThermostats;j++)
+    ThermostatNames[j] = new char[12];
+
+  strcpy(ThermostatNames[0],"None");
+  ThermostatImplemented[0] = 1;
+  strcpy(ThermostatNames[1],"Woodcock");
+  ThermostatImplemented[1] = 1;
+  strcpy(ThermostatNames[2],"Gaussian");
+  ThermostatImplemented[2] = 1;
+  strcpy(ThermostatNames[3],"Langevin");
+  ThermostatImplemented[3] = 1;
+  strcpy(ThermostatNames[4],"Berendsen");
+  ThermostatImplemented[4] = 1;
+  strcpy(ThermostatNames[5],"NoseHoover");
+  ThermostatImplemented[5] = 1;
+}
+
+/** Destructor for Class ThermoStatContainer.
+ *
+ */
+ThermoStatContainer::~ThermoStatContainer()
+{
+  delete[](ThermostatImplemented);
+  for (int j=0;j<MaxThermostats;j++)
+    delete[](ThermostatNames[j]);
+  delete[](ThermostatNames);
+}
+
+
Index: src/ThermoStatContainer.hpp
===================================================================
--- src/ThermoStatContainer.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
+++ src/ThermoStatContainer.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -0,0 +1,38 @@
+/*
+ * ThermoStatContainer.hpp
+ *
+ *  Created on: 12.06.2010
+ *      Author: heber
+ */
+
+#ifndef THERMOSTATCONTAINER_HPP_
+#define THERMOSTATCONTAINER_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+class ConfigFileBuffer;
+
+#define MaxThermostats 6      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented
+enum thermostats { None, Woodcock, Gaussian, Langevin, Berendsen, NoseHoover };   //!< Thermostat names for output
+
+class ThermoStatContainer {
+public:
+  ThermoStatContainer();
+  ~ThermoStatContainer();
+
+  void ParseThermostats(class ConfigFileBuffer * const fb);
+
+  int Thermostat;
+  int *ThermostatImplemented;
+  char **ThermostatNames;
+  double TempFrequency;
+  double alpha;
+  double HooverMass;
+  double TargetTemp;
+  int ScaleTempStep;
+};
+
+#endif /* THERMOSTATCONTAINER_HPP_ */
Index: src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -83,7 +83,11 @@
   // go through all possible actions
   for (std::list<std::string>::iterator CommandRunner = CommandLineParser::getInstance().SequenceOfActions.begin(); CommandRunner != CommandLineParser::getInstance().SequenceOfActions.end(); ++CommandRunner) {
-    cout << "Checking presence of " << *CommandRunner << endl;
-    if (ActionRegistry::getInstance().isActionByNamePresent(*CommandRunner))
+    cout << "Checking presence of " << *CommandRunner << ": ";
+    if (ActionRegistry::getInstance().isActionByNamePresent(*CommandRunner)) {
+      cout << "calling " << *CommandRunner << endl;
       ActionRegistry::getInstance().getActionByName(*CommandRunner)->call();
+    } else {
+      cout << "absent." << endl;
+    }
   }
 }
Index: src/World.cpp
===================================================================
--- src/World.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/World.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -14,4 +14,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "ThermoStatContainer.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "Descriptors/AtomDescriptor_impl.hpp"
@@ -89,4 +90,10 @@
   defaultName = name;
 };
+
+class ThermoStatContainer * World::getThermostats()
+{
+  return Thermostats;
+}
+
 
 int World::getExitFlag() {
@@ -281,4 +288,5 @@
     periode(new periodentafel),
     configuration(new config),
+    Thermostats(new ThermoStatContainer),
     ExitFlag(0),
     atoms(),
@@ -306,4 +314,5 @@
   delete periode;
   delete configuration;
+  delete Thermostats;
   MoleculeSet::iterator molIter;
   for(molIter=molecules.begin();molIter!=molecules.end();++molIter){
Index: src/World.hpp
===================================================================
--- src/World.hpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/World.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -30,16 +30,16 @@
 
 // forward declarations
-class config;
-class periodentafel;
-class MoleculeListClass;
 class atom;
-class molecule;
 class AtomDescriptor;
 class AtomDescriptor_impl;
+template<typename T> class AtomsCalculation;
+class config;
+class ManipulateAtomsProcess;
+class molecule;
 class MoleculeDescriptor;
 class MoleculeDescriptor_impl;
-class ManipulateAtomsProcess;
-template<typename T>
-class AtomsCalculation;
+class MoleculeListClass;
+class periodentafel;
+class ThermoStatContainer;
 
 /****************************************** forward declarations *****************************/
@@ -142,4 +142,9 @@
   void setDefaultName(std::string name);
 
+  /**
+   * get pointer to World's ThermoStatContainer
+   */
+  ThermoStatContainer * getThermostats();
+
   /*
    * get the ExitFlag
@@ -254,4 +259,5 @@
   static double *cell_size;
   std::string defaultName;
+  class ThermoStatContainer *Thermostats;
   int ExitFlag;
 public:
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/atom.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -159,5 +159,5 @@
   * \return true - \a *out present, false - \a *out is NULL
  */
-bool atom::OutputArrayIndexed(ofstream * const out, const int *ElementNo, int *AtomNo, const char *comment) const
+bool atom::OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment) const
 {
   AtomNo[type->Z]++;  // increment number
@@ -236,5 +236,5 @@
  * \param *AtomNo pointer to atom counter that is increased by one
  */
-void atom::OutputMPQCLine(ofstream * const out, const Vector *center, int *AtomNo = NULL) const
+void atom::OutputMPQCLine(ostream * const out, const Vector *center, int *AtomNo = NULL) const
 {
   *out << "\t\t" << type->symbol << " [ " << x[0]-center->at(0) << "\t" << x[1]-center->at(1) << "\t" << x[2]-center->at(2) << " ]" << endl;
Index: src/atom.hpp
===================================================================
--- src/atom.hpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/atom.hpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -51,9 +51,9 @@
 
   bool OutputIndexed(ofstream * const out, const int ElementNo, const int AtomNo, const char *comment = NULL) const;
-  bool OutputArrayIndexed(ofstream * const out, const int *ElementNo, int *AtomNo, const char *comment = NULL) const;
+  bool OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment = NULL) const;
   bool OutputXYZLine(ofstream *out) const;
   bool OutputTrajectory(ofstream * const out, const int *ElementNo, int *AtomNo, const int step) const;
   bool OutputTrajectoryXYZ(ofstream * const out, const int step) const;
-  void OutputMPQCLine(ofstream * const out, const Vector *center, int *AtomNo) const;
+  void OutputMPQCLine(ostream * const out, const Vector *center, int *AtomNo) const;
 
   void InitComponentNr();
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/atom_trajectoryparticle.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -15,4 +15,5 @@
 #include "log.hpp"
 #include "parser.hpp"
+#include "ThermoStatContainer.hpp"
 #include "verbose.hpp"
 
@@ -197,9 +198,9 @@
 void TrajectoryParticle::Thermostat_Langevin(int Step, gsl_rng * r, double *ekin, config *configuration)
 {
-  double sigma  = sqrt(configuration->TargetTemp/type->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
+  double sigma  = sqrt(configuration->Thermostats->TargetTemp/type->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
   Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     // throw a dice to determine whether it gets hit by a heat bath particle
-    if (((((rand()/(double)RAND_MAX))*configuration->TempFrequency) < 1.)) {
+    if (((((rand()/(double)RAND_MAX))*configuration->Thermostats->TempFrequency) < 1.)) {
       DoLog(3) && (Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ");
       // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
@@ -225,5 +226,5 @@
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
-      U[d] *= sqrt(1+(configuration->Deltat/configuration->TempFrequency)*(ScaleTempFactor-1));
+      U[d] *= sqrt(1+(configuration->Deltat/configuration->Thermostats->TempFrequency)*(ScaleTempFactor-1));
       *ekin += 0.5*type->mass * U[d]*U[d];
     }
@@ -255,5 +256,5 @@
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
-        U[d] += configuration->Deltat/type->mass * (configuration->alpha * (U[d] * type->mass));
+        U[d] += configuration->Deltat/type->mass * (configuration->Thermostats->alpha * (U[d] * type->mass));
         *ekin += (0.5*type->mass) * U[d]*U[d];
       }
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision f34c238ce5cc901d49c2b7d96c15786b1d2d390d)
+++ src/builder.cpp	(revision d3dff06e8fff78fceae7c93eb68106e91329b667)
@@ -79,4 +79,5 @@
 #include "UIElements/Dialog.hpp"
 #include "Menu/ActionMenuItem.hpp"
+#include "Parser/ChangeTracker.hpp"
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/ActionHistory.hpp"
@@ -1691,11 +1692,8 @@
               } else {
                 SaveFlag = true;
-                DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
-                if (!mol->AddXYZFile(argv[argptr]))
-                  DoLog(2) && (Log() << Verbose(2) << "File not found." << endl);
-                else {
-                  DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
-                  configPresent = present;
-                }
+                configPresent = present;
+                ArgcList.insert(argptr-1);
+                ArgcList.insert(argptr);
+                argptr+=1;
               }
               break;
@@ -2181,4 +2179,5 @@
 
 void cleanUp(){
+  ChangeTracker::purgeInstance();
   World::purgeInstance();
   logger::purgeInstance();
